searchNodes=[{"ref":"Riemannx.html","title":"Riemannx","type":"module","doc":"Riemannx is a riemann client that supports UDP/TCP/TLS sockets and also supports a hybrid connection where smaller packets are sent via UDP and the rest over TCP. All connection types can also have a batching layer added over the top. Examples To use riemannx all you need to do is fill out some config entries - after that everything just happens automagically (save for the actual sending of course): config :riemannx, [ host: &quot;localhost&quot;, # The riemann server event_host: &quot;my_app&quot;, # You can override the host name sent to riemann if you want (see: Host Injection) type: :batch, # The type of connection you want to run (:tcp, :udp, :tls, :combined, :batch) settings_module: Riemannx.Settings.Default # The backend used for reading settings back metrics_module: Riemannx.Metrics.Default # The backend used for sending metrics use_micro: true # Set to false if you use a riemann version before 0.2.13 batch_settings: [ type: :combined # The underlying connection to use when using batching. size: 50, # The size of batches to send to riemann. interval: {1, :seconds} # The interval at which to send batches. ] tcp: [ port: 5555, retry_count: 5, # How many times to re-attempt a TCP connection retry_interval: 1000, # Interval to wait before the next TCP connection attempt (milliseconds). priority: :high, # Priority to give TCP workers. options: [], # Specify additional options to be passed to gen_tcp (NOTE: [:binary, nodelay: true, packet: 4, active: true] will be added to whatever you type here as they are deemed essential) pool_size: 5, # How many TCP workers should be in the pool. max_overflow: 5, # Under heavy load how many more TCP workers can be created to meet demand? strategy: :fifo # The poolboy strategy for retrieving workers from the queue ], udp: [ port: 5555, priority: :high, options: [], # Specify additional options to be passed to gen_udp (NOTE: [:binary, sndbuf: max_udp_size()] will be added to whatever you type here as they are deemed essential) max_size: 16_384, # Maximum accepted packet size (this is configured in your Riemann server) pool_size: 5, max_overflow: 5, strategy: :fifo ], tls: [ port: 5554, retry_count: 5, # How many times to re-attempt a TLS connection retry_interval: 1000, # Interval to wait before the next TLS connection attempt (milliseconds). priority: :high, options: [], # Specify additional options to be passed to :ssl (NOTE: [:binary, nodelay: true, packet: 4, active: true] will be added to whatever you type here as they are deemed essential) pool_size: 5, max_overflow: 5, strategy: :fifo ] ] Worker Behaviour If a worker is unable to send it will die and be restarted giving it a chance to return to a &#39;correct&#39; state. On an asynchronous send this is done by pattern matching :ok with the send command, for synchronous sends if the return value is an error we kill the worker before returning the result."},{"ref":"Riemannx.html#create_events_msg/1","title":"Riemannx.create_events_msg/1","type":"function","doc":"Constructs a protobuf message based on an event or list of events."},{"ref":"Riemannx.html#query/2","title":"Riemannx.query/2","type":"function","doc":"Riemann has the concept of a queryable index which allows you to search for specific events, indexes must be specially created in your config otherwise the server will return a &quot;no index&quot; error. # Lets send an event that we can then query Riemannx.send([service: &quot;riemannx&quot;, metric: 5.0, attributes: [v: &quot;2.2.0&quot;]]) # Let&#39;s fish it out events = Riemannx.query(&#39;service ~= &quot;riemannx&quot;&#39;) # [%{attributes: %{&quot;v&quot; =&gt; &quot;2.2.0&quot;}, description: nil, host: _, # metric: nil, service: &quot;riemannx&quot;, state: nil, tags: [], # time: _, ttl: _}] For more information on querying and the language features have a look at the Core Concepts."},{"ref":"Riemannx.html#send/1","title":"Riemannx.send/1","type":"function","doc":"Synchronous sending allows you to handle the errors that might occur during send, below is an example showing both how this error looks and what happens on a successful send: event = [service: &quot;riemannx-elixir&quot;, metric: 1, attributes: [a: 1], description: &quot;test&quot;] case Riemannx.send(event) do :ok -&gt; &quot;Success!&quot; [error: error, msg: encoded_msg] -&gt; # The error will always be a string so you can output it as it is. # # The encoded message is a binary blob but you can use the riemannx proto # msg module to decode it if you wish to see it in human readable form. msg = encoded_msg |&gt; Riemannx.Proto.Msg.decode() end"},{"ref":"Riemannx.html#send_async/1","title":"Riemannx.send_async/1","type":"function","doc":"Asynchronous sending is much faster but you never really know if your message made it, in a lot of cases this kind of sending is safe enough and for most use cases the recommended choice. It&#39;s fairly simple to implement: event = [service: &quot;riemannx-elixir&quot;, metric: 1, attributes: [a: 1], description: &quot;test&quot;] Riemannx.send_async(event) # Who knows if it made it? Who cares? 60% of the time it works everytime!"},{"ref":"Riemannx.html#t:events/0","title":"Riemannx.events/0","type":"type","doc":""},{"ref":"Riemannx.Connection.html","title":"Riemannx.Connection","type":"behaviour","doc":"This is the behaviour specification for all connections as well as a generic API for communication with them based on the settings given in your config. The struct in this module is used across all connection types as much of the data is common to all types."},{"ref":"Riemannx.Connection.html#query/2","title":"Riemannx.Connection.query/2","type":"function","doc":"Query the index of the riemann server, only works with the TLS/TCP/Combined setups. UDP is NOT supported."},{"ref":"Riemannx.Connection.html#c:query/2","title":"Riemannx.Connection.query/2","type":"callback","doc":""},{"ref":"Riemannx.Connection.html#query_failed/0","title":"Riemannx.Connection.query_failed/0","type":"function","doc":"A failed query."},{"ref":"Riemannx.Connection.html#query_ok/0","title":"Riemannx.Connection.query_ok/0","type":"function","doc":"An acceptable query response."},{"ref":"Riemannx.Connection.html#send/2","title":"Riemannx.Connection.send/2","type":"function","doc":"Synchronously process an event."},{"ref":"Riemannx.Connection.html#c:send/2","title":"Riemannx.Connection.send/2","type":"callback","doc":""},{"ref":"Riemannx.Connection.html#send_async/1","title":"Riemannx.Connection.send_async/1","type":"function","doc":"Tells the given worker to asynchronously process an event."},{"ref":"Riemannx.Connection.html#c:send_async/1","title":"Riemannx.Connection.send_async/1","type":"callback","doc":""},{"ref":"Riemannx.Connection.html#t:encoded_event/0","title":"Riemannx.Connection.encoded_event/0","type":"type","doc":""},{"ref":"Riemannx.Connection.html#t:error/0","title":"Riemannx.Connection.error/0","type":"type","doc":""},{"ref":"Riemannx.Connection.html#t:qr/0","title":"Riemannx.Connection.qr/0","type":"type","doc":""},{"ref":"Riemannx.Connection.html#t:query/0","title":"Riemannx.Connection.query/0","type":"type","doc":""},{"ref":"Riemannx.Connection.html#t:retry_count/0","title":"Riemannx.Connection.retry_count/0","type":"type","doc":""},{"ref":"Riemannx.Connection.html#t:socket/0","title":"Riemannx.Connection.socket/0","type":"type","doc":""},{"ref":"Riemannx.Connection.html#t:t/0","title":"Riemannx.Connection.t/0","type":"type","doc":""},{"ref":"Riemannx.Connections.Batch.html","title":"Riemannx.Connections.Batch","type":"module","doc":"The batch connector is a pass through module that adds batching functionality on top of the existing protocol connections. Batching will aggregate events you send and then send them in bulk in intervals you specify, if the events reach a certain size you can set it so they publish the events before the interval. NOTE: Batching only works with send_async. Below is how the batching settings look in config: config :riemannx, [ type: :batch batch_settings: [ type: :combined size: 50 # Sends when the batch size reaches 50 interval: {5, :seconds} # How often to send the batches if they don&#39;t reach :size (:seconds, :minutes or :milliseconds) ] ] ## Synchronous Sending When you send synchronously the events are passed directly through to the underlying connection module. They are not batched or put in the queue."},{"ref":"Riemannx.Connections.Batch.html#child_spec/1","title":"Riemannx.Connections.Batch.child_spec/1","type":"function","doc":"Returns a specification to start this module under a supervisor. See Supervisor."},{"ref":"Riemannx.Connections.Batch.html#init/1","title":"Riemannx.Connections.Batch.init/1","type":"function","doc":"Invoked when the server is started. start_link/3 or start/3 will block until it returns. init_arg is the argument term (second argument) passed to start_link/3. Returning {:ok, state} will cause start_link/3 to return {:ok, pid} and the process to enter its loop. Returning {:ok, state, timeout} is similar to {:ok, state} except handle_info(:timeout, state) will be called after timeout milliseconds if no messages are received within the timeout. Returning {:ok, state, :hibernate} is similar to {:ok, state} except the process is hibernated before entering the loop. See c:handle_call/3 for more information on hibernation. Returning {:ok, state, {:continue, continue}} is similar to {:ok, state} except that immediately after entering the loop the c:handle_continue/2 callback will be invoked with the value continue as first argument. Returning :ignore will cause start_link/3 to return :ignore and the process will exit normally without entering the loop or calling c:terminate/2. If used when part of a supervision tree the parent supervisor will not fail to start nor immediately try to restart the GenServer. The remainder of the supervision tree will be started and so the GenServer should not be required by other processes. It can be started later with Supervisor.restart_child/2 as the child specification is saved in the parent supervisor. The main use cases for this are: The GenServer is disabled by configuration but might be enabled later. An error occurred and it will be handled by a different mechanism than the Supervisor. Likely this approach involves calling Supervisor.restart_child/2 after a delay to attempt a restart. Returning {:stop, reason} will cause start_link/3 to return {:error, reason} and the process to exit with reason reason without entering the loop or calling c:terminate/2. Callback implementation for GenServer.init/1."},{"ref":"Riemannx.Connections.Batch.html#query/2","title":"Riemannx.Connections.Batch.query/2","type":"function","doc":"Callback implementation for Riemannx.Connection.query/2."},{"ref":"Riemannx.Connections.Batch.html#send/2","title":"Riemannx.Connections.Batch.send/2","type":"function","doc":"Callback implementation for Riemannx.Connection.send/2."},{"ref":"Riemannx.Connections.Batch.html#send_async/1","title":"Riemannx.Connections.Batch.send_async/1","type":"function","doc":"Callback implementation for Riemannx.Connection.send_async/1."},{"ref":"Riemannx.Connections.Batch.html#start_link/1","title":"Riemannx.Connections.Batch.start_link/1","type":"function","doc":""},{"ref":"Riemannx.Connections.Batch.Queue.html","title":"Riemannx.Connections.Batch.Queue","type":"module","doc":"Queue implementation for the batch module Internally it maintains two queues: buffer: Contains the latest elements being inserted before the size of a batch is reached batches: It has the ordered list of batches ready to be sent as required The main idea is that batches are created as the queue is filled up. In this way, it avoids problems if the amount of events to be sent is too big as everything is precalculated on a smaller queue (buffer)"},{"ref":"Riemannx.Connections.Batch.Queue.html#batch_available?/1","title":"Riemannx.Connections.Batch.Queue.batch_available?/1","type":"function","doc":""},{"ref":"Riemannx.Connections.Batch.Queue.html#get_batch/1","title":"Riemannx.Connections.Batch.Queue.get_batch/1","type":"function","doc":""},{"ref":"Riemannx.Connections.Batch.Queue.html#new/0","title":"Riemannx.Connections.Batch.Queue.new/0","type":"function","doc":""},{"ref":"Riemannx.Connections.Batch.Queue.html#push/2","title":"Riemannx.Connections.Batch.Queue.push/2","type":"function","doc":""},{"ref":"Riemannx.Connections.Combined.html","title":"Riemannx.Connections.Combined","type":"module","doc":"The combined connection worker works out when it&#39;s possible to use UDP and will transmit via TCP when the message size exceeds the total max byte size. This ensures you get the non-blocking behaviour of UDP without dropping events if they exceed the byte size configured on the Riemann server. This connection is the recommended default. Special Notes The callback functions in this module simply route to the callback functions in either the TCP or UDP modules based on a simple byte_size check of the given event. Even though this is the recommended default that is based on my use-case for this library. Your requirements may be VERY different. Using UDP at all is unreliable but in my use case I don&#39;t care if some events don&#39;t make it, in situations it is absolutely critical your events make it in order and reliably you should use TCP. In fact Riemann themeselves recommend TCP only."},{"ref":"Riemannx.Connections.Combined.html#query/2","title":"Riemannx.Connections.Combined.query/2","type":"function","doc":"Callback implementation for Riemannx.Connection.query/2."},{"ref":"Riemannx.Connections.Combined.html#send/2","title":"Riemannx.Connections.Combined.send/2","type":"function","doc":"Callback implementation for Riemannx.Connection.send/2."},{"ref":"Riemannx.Connections.Combined.html#send_async/1","title":"Riemannx.Connections.Combined.send_async/1","type":"function","doc":"Callback implementation for Riemannx.Connection.send_async/1."},{"ref":"Riemannx.Connections.TCP.html","title":"Riemannx.Connections.TCP","type":"module","doc":"Using the TCP connection will only send traffic via TCP, all traffic can be sent via TCP as opposed to UDP where you are limited by packet size, there is however an overhead penalty using purely TCP which is why the combined connection is the recommended default. Special Notes This library was built for my use-case which required speed at the expense of reliability hence why combined is the default. If, however you require guarantees on message order then TCP / TLS is the way to go."},{"ref":"Riemannx.Connections.TCP.html#child_spec/1","title":"Riemannx.Connections.TCP.child_spec/1","type":"function","doc":"Returns a specification to start this module under a supervisor. See Supervisor."},{"ref":"Riemannx.Connections.TCP.html#get_worker/0","title":"Riemannx.Connections.TCP.get_worker/0","type":"function","doc":""},{"ref":"Riemannx.Connections.TCP.html#init/1","title":"Riemannx.Connections.TCP.init/1","type":"function","doc":"Invoked when the server is started. start_link/3 or start/3 will block until it returns. init_arg is the argument term (second argument) passed to start_link/3. Returning {:ok, state} will cause start_link/3 to return {:ok, pid} and the process to enter its loop. Returning {:ok, state, timeout} is similar to {:ok, state} except handle_info(:timeout, state) will be called after timeout milliseconds if no messages are received within the timeout. Returning {:ok, state, :hibernate} is similar to {:ok, state} except the process is hibernated before entering the loop. See c:handle_call/3 for more information on hibernation. Returning {:ok, state, {:continue, continue}} is similar to {:ok, state} except that immediately after entering the loop the c:handle_continue/2 callback will be invoked with the value continue as first argument. Returning :ignore will cause start_link/3 to return :ignore and the process will exit normally without entering the loop or calling c:terminate/2. If used when part of a supervision tree the parent supervisor will not fail to start nor immediately try to restart the GenServer. The remainder of the supervision tree will be started and so the GenServer should not be required by other processes. It can be started later with Supervisor.restart_child/2 as the child specification is saved in the parent supervisor. The main use cases for this are: The GenServer is disabled by configuration but might be enabled later. An error occurred and it will be handled by a different mechanism than the Supervisor. Likely this approach involves calling Supervisor.restart_child/2 after a delay to attempt a restart. Returning {:stop, reason} will cause start_link/3 to return {:error, reason} and the process to exit with reason reason without entering the loop or calling c:terminate/2. Callback implementation for GenServer.init/1."},{"ref":"Riemannx.Connections.TCP.html#query/2","title":"Riemannx.Connections.TCP.query/2","type":"function","doc":"Callback implementation for Riemannx.Connection.query/2."},{"ref":"Riemannx.Connections.TCP.html#release/1","title":"Riemannx.Connections.TCP.release/1","type":"function","doc":""},{"ref":"Riemannx.Connections.TCP.html#send/2","title":"Riemannx.Connections.TCP.send/2","type":"function","doc":"Callback implementation for Riemannx.Connection.send/2."},{"ref":"Riemannx.Connections.TCP.html#send_async/1","title":"Riemannx.Connections.TCP.send_async/1","type":"function","doc":"Callback implementation for Riemannx.Connection.send_async/1."},{"ref":"Riemannx.Connections.TCP.html#start_link/1","title":"Riemannx.Connections.TCP.start_link/1","type":"function","doc":""},{"ref":"Riemannx.Connections.TLS.html","title":"Riemannx.Connections.TLS","type":"module","doc":"TLS is a secure TCP connection, you can use this if communicating with your riemann server securely is important - it carries some overhead and is much slower than UDP/combined but the trade-off is obviously worth it if security is a concern. Special Notes This library was built for my use-case which required speed at the expense of reliability hence why combined is the default. If, however you require guarantees on message order then TCP / TLS is the way to go."},{"ref":"Riemannx.Connections.TLS.html#child_spec/1","title":"Riemannx.Connections.TLS.child_spec/1","type":"function","doc":"Returns a specification to start this module under a supervisor. See Supervisor."},{"ref":"Riemannx.Connections.TLS.html#get_worker/0","title":"Riemannx.Connections.TLS.get_worker/0","type":"function","doc":""},{"ref":"Riemannx.Connections.TLS.html#init/1","title":"Riemannx.Connections.TLS.init/1","type":"function","doc":"Invoked when the server is started. start_link/3 or start/3 will block until it returns. init_arg is the argument term (second argument) passed to start_link/3. Returning {:ok, state} will cause start_link/3 to return {:ok, pid} and the process to enter its loop. Returning {:ok, state, timeout} is similar to {:ok, state} except handle_info(:timeout, state) will be called after timeout milliseconds if no messages are received within the timeout. Returning {:ok, state, :hibernate} is similar to {:ok, state} except the process is hibernated before entering the loop. See c:handle_call/3 for more information on hibernation. Returning {:ok, state, {:continue, continue}} is similar to {:ok, state} except that immediately after entering the loop the c:handle_continue/2 callback will be invoked with the value continue as first argument. Returning :ignore will cause start_link/3 to return :ignore and the process will exit normally without entering the loop or calling c:terminate/2. If used when part of a supervision tree the parent supervisor will not fail to start nor immediately try to restart the GenServer. The remainder of the supervision tree will be started and so the GenServer should not be required by other processes. It can be started later with Supervisor.restart_child/2 as the child specification is saved in the parent supervisor. The main use cases for this are: The GenServer is disabled by configuration but might be enabled later. An error occurred and it will be handled by a different mechanism than the Supervisor. Likely this approach involves calling Supervisor.restart_child/2 after a delay to attempt a restart. Returning {:stop, reason} will cause start_link/3 to return {:error, reason} and the process to exit with reason reason without entering the loop or calling c:terminate/2. Callback implementation for GenServer.init/1."},{"ref":"Riemannx.Connections.TLS.html#query/2","title":"Riemannx.Connections.TLS.query/2","type":"function","doc":"Callback implementation for Riemannx.Connection.query/2."},{"ref":"Riemannx.Connections.TLS.html#release/1","title":"Riemannx.Connections.TLS.release/1","type":"function","doc":""},{"ref":"Riemannx.Connections.TLS.html#send/2","title":"Riemannx.Connections.TLS.send/2","type":"function","doc":"Callback implementation for Riemannx.Connection.send/2."},{"ref":"Riemannx.Connections.TLS.html#send_async/1","title":"Riemannx.Connections.TLS.send_async/1","type":"function","doc":"Callback implementation for Riemannx.Connection.send_async/1."},{"ref":"Riemannx.Connections.TLS.html#start_link/1","title":"Riemannx.Connections.TLS.start_link/1","type":"function","doc":""},{"ref":"Riemannx.Connections.UDP.html","title":"Riemannx.Connections.UDP","type":"module","doc":"Using the UDP connection is not recommended at all, events will be dropped if they exceed the max_udp_size set. You can increase this server side and set the desired value in this client."},{"ref":"Riemannx.Connections.UDP.html#child_spec/1","title":"Riemannx.Connections.UDP.child_spec/1","type":"function","doc":"Returns a specification to start this module under a supervisor. See Supervisor."},{"ref":"Riemannx.Connections.UDP.html#get_worker/1","title":"Riemannx.Connections.UDP.get_worker/1","type":"function","doc":""},{"ref":"Riemannx.Connections.UDP.html#init/1","title":"Riemannx.Connections.UDP.init/1","type":"function","doc":"Invoked when the server is started. start_link/3 or start/3 will block until it returns. init_arg is the argument term (second argument) passed to start_link/3. Returning {:ok, state} will cause start_link/3 to return {:ok, pid} and the process to enter its loop. Returning {:ok, state, timeout} is similar to {:ok, state} except handle_info(:timeout, state) will be called after timeout milliseconds if no messages are received within the timeout. Returning {:ok, state, :hibernate} is similar to {:ok, state} except the process is hibernated before entering the loop. See c:handle_call/3 for more information on hibernation. Returning {:ok, state, {:continue, continue}} is similar to {:ok, state} except that immediately after entering the loop the c:handle_continue/2 callback will be invoked with the value continue as first argument. Returning :ignore will cause start_link/3 to return :ignore and the process will exit normally without entering the loop or calling c:terminate/2. If used when part of a supervision tree the parent supervisor will not fail to start nor immediately try to restart the GenServer. The remainder of the supervision tree will be started and so the GenServer should not be required by other processes. It can be started later with Supervisor.restart_child/2 as the child specification is saved in the parent supervisor. The main use cases for this are: The GenServer is disabled by configuration but might be enabled later. An error occurred and it will be handled by a different mechanism than the Supervisor. Likely this approach involves calling Supervisor.restart_child/2 after a delay to attempt a restart. Returning {:stop, reason} will cause start_link/3 to return {:error, reason} and the process to exit with reason reason without entering the loop or calling c:terminate/2. Callback implementation for GenServer.init/1."},{"ref":"Riemannx.Connections.UDP.html#query/2","title":"Riemannx.Connections.UDP.query/2","type":"function","doc":"Callback implementation for Riemannx.Connection.query/2."},{"ref":"Riemannx.Connections.UDP.html#release/1","title":"Riemannx.Connections.UDP.release/1","type":"function","doc":""},{"ref":"Riemannx.Connections.UDP.html#send/2","title":"Riemannx.Connections.UDP.send/2","type":"function","doc":"Callback implementation for Riemannx.Connection.send/2."},{"ref":"Riemannx.Connections.UDP.html#send_async/1","title":"Riemannx.Connections.UDP.send_async/1","type":"function","doc":"Callback implementation for Riemannx.Connection.send_async/1."},{"ref":"Riemannx.Connections.UDP.html#start_link/1","title":"Riemannx.Connections.UDP.start_link/1","type":"function","doc":""},{"ref":"Riemannx.Errors.InvalidMetricError.html","title":"Riemannx.Errors.InvalidMetricError","type":"exception","doc":""},{"ref":"Riemannx.Metrics.html","title":"Riemannx.Metrics","type":"behaviour","doc":"This is the callback module for metrics, you can extend this to report metrics to any kind of metric software (graphite, influx etc.)"},{"ref":"Riemannx.Metrics.html#tcp_message_sent/1","title":"Riemannx.Metrics.tcp_message_sent/1","type":"function","doc":""},{"ref":"Riemannx.Metrics.html#c:tcp_message_sent/1","title":"Riemannx.Metrics.tcp_message_sent/1","type":"callback","doc":""},{"ref":"Riemannx.Metrics.html#tls_message_sent/1","title":"Riemannx.Metrics.tls_message_sent/1","type":"function","doc":""},{"ref":"Riemannx.Metrics.html#c:tls_message_sent/1","title":"Riemannx.Metrics.tls_message_sent/1","type":"callback","doc":""},{"ref":"Riemannx.Metrics.html#udp_message_sent/1","title":"Riemannx.Metrics.udp_message_sent/1","type":"function","doc":""},{"ref":"Riemannx.Metrics.html#c:udp_message_sent/1","title":"Riemannx.Metrics.udp_message_sent/1","type":"callback","doc":""},{"ref":"Riemannx.Metrics.Default.html","title":"Riemannx.Metrics.Default","type":"module","doc":"The default metrics backend which does nothing."},{"ref":"Riemannx.Metrics.Default.html#tcp_message_sent/1","title":"Riemannx.Metrics.Default.tcp_message_sent/1","type":"function","doc":"Callback implementation for Riemannx.Metrics.tcp_message_sent/1."},{"ref":"Riemannx.Metrics.Default.html#tls_message_sent/1","title":"Riemannx.Metrics.Default.tls_message_sent/1","type":"function","doc":"Callback implementation for Riemannx.Metrics.tls_message_sent/1."},{"ref":"Riemannx.Metrics.Default.html#udp_message_sent/1","title":"Riemannx.Metrics.Default.udp_message_sent/1","type":"function","doc":"Callback implementation for Riemannx.Metrics.udp_message_sent/1."},{"ref":"Riemannx.Settings.html","title":"Riemannx.Settings","type":"behaviour","doc":"This is the callback module for settings, you can extend this if you wish to store your riemannx settings elsewhere like a database."},{"ref":"Riemannx.Settings.html#batch_interval/0","title":"Riemannx.Settings.batch_interval/0","type":"function","doc":"Returns the batch interval. Default: {1, :minutes}"},{"ref":"Riemannx.Settings.html#c:batch_interval/0","title":"Riemannx.Settings.batch_interval/0","type":"callback","doc":""},{"ref":"Riemannx.Settings.html#batch_module/0","title":"Riemannx.Settings.batch_module/0","type":"function","doc":"Returns the batch module, relevant if using the batching connection. Default: Riemannx.Connections.Combined"},{"ref":"Riemannx.Settings.html#c:batch_module/0","title":"Riemannx.Settings.batch_module/0","type":"callback","doc":""},{"ref":"Riemannx.Settings.html#batch_size/0","title":"Riemannx.Settings.batch_size/0","type":"function","doc":"Returns the batch size. Default: 100"},{"ref":"Riemannx.Settings.html#c:batch_size/0","title":"Riemannx.Settings.batch_size/0","type":"callback","doc":""},{"ref":"Riemannx.Settings.html#batch_type/0","title":"Riemannx.Settings.batch_type/0","type":"function","doc":"Returns the batch type, similar to type() but is used to provide a connection module to the batching wrapper. Default: :combined"},{"ref":"Riemannx.Settings.html#c:batch_type/0","title":"Riemannx.Settings.batch_type/0","type":"callback","doc":""},{"ref":"Riemannx.Settings.html#checkout_timeout/0","title":"Riemannx.Settings.checkout_timeout/0","type":"function","doc":"The maximum number of seconds to wait for a free worker before discarding data, :infinity is a valid value here and means you will wait for eternity for a free worker. Note that :infinity can cause a build-up of messages in your process inbox if using the batcher and your riemann instance experiences an outage! DATA MAY BE DISCARDED IF NO AVAILABLE WORKER IS PRESENT AFTER THIS TIMEOUT! Default: 30_000"},{"ref":"Riemannx.Settings.html#c:checkout_timeout/0","title":"Riemannx.Settings.checkout_timeout/0","type":"callback","doc":""},{"ref":"Riemannx.Settings.html#events_host/0","title":"Riemannx.Settings.events_host/0","type":"function","doc":"Returns the host name that will be appended to events. Default: derived using :inets.gethostname."},{"ref":"Riemannx.Settings.html#c:events_host/0","title":"Riemannx.Settings.events_host/0","type":"callback","doc":""},{"ref":"Riemannx.Settings.html#host/0","title":"Riemannx.Settings.host/0","type":"function","doc":"Returns the riemann host. Default: localhost"},{"ref":"Riemannx.Settings.html#c:host/0","title":"Riemannx.Settings.host/0","type":"callback","doc":""},{"ref":"Riemannx.Settings.html#max_overflow/1","title":"Riemannx.Settings.max_overflow/1","type":"function","doc":"The max overflow for the poolboy pool, this value determines how many extra workers can be created under high load. Default: 20"},{"ref":"Riemannx.Settings.html#c:max_overflow/1","title":"Riemannx.Settings.max_overflow/1","type":"callback","doc":""},{"ref":"Riemannx.Settings.html#max_udp_size/0","title":"Riemannx.Settings.max_udp_size/0","type":"function","doc":"Returns the maximum size allowed for a UDP packet. Default: 16_384"},{"ref":"Riemannx.Settings.html#c:max_udp_size/0","title":"Riemannx.Settings.max_udp_size/0","type":"callback","doc":""},{"ref":"Riemannx.Settings.html#metrics_module/0","title":"Riemannx.Settings.metrics_module/0","type":"function","doc":"Returns the set metrics module. Default: Riemannx.Metrics.Default"},{"ref":"Riemannx.Settings.html#c:metrics_module/0","title":"Riemannx.Settings.metrics_module/0","type":"callback","doc":""},{"ref":"Riemannx.Settings.html#module/0","title":"Riemannx.Settings.module/0","type":"function","doc":"Returns the correct connection backend based on the set type. Default: Riemannx.Connections.Combined"},{"ref":"Riemannx.Settings.html#module/1","title":"Riemannx.Settings.module/1","type":"function","doc":"Returns the module related to the given type."},{"ref":"Riemannx.Settings.html#c:module/1","title":"Riemannx.Settings.module/1","type":"callback","doc":""},{"ref":"Riemannx.Settings.html#options/1","title":"Riemannx.Settings.options/1","type":"function","doc":"Returns the options that will be passed to the underlying gen_tcp/udp/ssl server. NOTE: There are some things that will be appended to whatever you put in the options field as they are deemed essential to the operation of the library: tcp: [:binary, nodelay: true, packet: 4, active: true] tls: [:binary, nodelay: true, packet: 4, active: true] udp: [:binary, sndbuf: max_udp_size()] Defaults: tcp: [] tls: [] udp: []"},{"ref":"Riemannx.Settings.html#c:options/1","title":"Riemannx.Settings.options/1","type":"callback","doc":""},{"ref":"Riemannx.Settings.html#pool_name/1","title":"Riemannx.Settings.pool_name/1","type":"function","doc":"Pool name is the name of the poolboy pool, they MUST be unique for each connection type. Defaults: tcp: :riemannx_tcp tls: :riemannx_tls udp: :riemannx_udp"},{"ref":"Riemannx.Settings.html#c:pool_name/1","title":"Riemannx.Settings.pool_name/1","type":"callback","doc":""},{"ref":"Riemannx.Settings.html#pool_size/1","title":"Riemannx.Settings.pool_size/1","type":"function","doc":"Pool size returns the set pool size given the connection type. Default: 10"},{"ref":"Riemannx.Settings.html#c:pool_size/1","title":"Riemannx.Settings.pool_size/1","type":"callback","doc":""},{"ref":"Riemannx.Settings.html#port/1","title":"Riemannx.Settings.port/1","type":"function","doc":"Returns the set port for the given connection type. Default: 5555"},{"ref":"Riemannx.Settings.html#c:port/1","title":"Riemannx.Settings.port/1","type":"callback","doc":""},{"ref":"Riemannx.Settings.html#priority!/1","title":"Riemannx.Settings.priority!/1","type":"function","doc":"Returns the set priority for the workers based on type. Default: :normal"},{"ref":"Riemannx.Settings.html#c:priority!/1","title":"Riemannx.Settings.priority!/1","type":"callback","doc":""},{"ref":"Riemannx.Settings.html#retry_count/1","title":"Riemannx.Settings.retry_count/1","type":"function","doc":"Returns the amount of times a worker should re-attempt a connection before giving up. You can set :infinity if you want to try until it&#39;s available. Default: 5"},{"ref":"Riemannx.Settings.html#c:retry_count/1","title":"Riemannx.Settings.retry_count/1","type":"callback","doc":""},{"ref":"Riemannx.Settings.html#retry_interval/1","title":"Riemannx.Settings.retry_interval/1","type":"function","doc":"Returns the time in milliseconds to wait between each connection re-attempt. Default: 5000"},{"ref":"Riemannx.Settings.html#c:retry_interval/1","title":"Riemannx.Settings.retry_interval/1","type":"callback","doc":""},{"ref":"Riemannx.Settings.html#send_timeout/0","title":"Riemannx.Settings.send_timeout/0","type":"function","doc":"Returns the timeout for sending a synchronous message, once the timeout is reached the riemannx batch connection will catch the error and try sending again. Other backends will error as normal. Give in seconds. Default: 5"},{"ref":"Riemannx.Settings.html#c:send_timeout/0","title":"Riemannx.Settings.send_timeout/0","type":"callback","doc":""},{"ref":"Riemannx.Settings.html#settings_module/0","title":"Riemannx.Settings.settings_module/0","type":"function","doc":"Returns the settings backend module you are using. Default: Riemannx.Settings.Default"},{"ref":"Riemannx.Settings.html#strategy/1","title":"Riemannx.Settings.strategy/1","type":"function","doc":"The poolboy worker strategy, see the poolboy docs for more info on strategy. Default: :fifo"},{"ref":"Riemannx.Settings.html#c:strategy/1","title":"Riemannx.Settings.strategy/1","type":"callback","doc":""},{"ref":"Riemannx.Settings.html#type/0","title":"Riemannx.Settings.type/0","type":"function","doc":"Returns the connection type set (tls, tcp, udp, combined, batch). Default: :combined"},{"ref":"Riemannx.Settings.html#c:type/0","title":"Riemannx.Settings.type/0","type":"callback","doc":""},{"ref":"Riemannx.Settings.html#t:conn_type/0","title":"Riemannx.Settings.conn_type/0","type":"type","doc":""},{"ref":"Riemannx.Settings.html#t:priority/0","title":"Riemannx.Settings.priority/0","type":"type","doc":""},{"ref":"Riemannx.Settings.Default.html","title":"Riemannx.Settings.Default","type":"module","doc":"This module follows the default config format as of 3.0.0."},{"ref":"Riemannx.Settings.Default.html#batch_interval/0","title":"Riemannx.Settings.Default.batch_interval/0","type":"function","doc":"Callback implementation for Riemannx.Settings.batch_interval/0."},{"ref":"Riemannx.Settings.Default.html#batch_module/0","title":"Riemannx.Settings.Default.batch_module/0","type":"function","doc":"Callback implementation for Riemannx.Settings.batch_module/0."},{"ref":"Riemannx.Settings.Default.html#batch_size/0","title":"Riemannx.Settings.Default.batch_size/0","type":"function","doc":"Callback implementation for Riemannx.Settings.batch_size/0."},{"ref":"Riemannx.Settings.Default.html#batch_type/0","title":"Riemannx.Settings.Default.batch_type/0","type":"function","doc":"Callback implementation for Riemannx.Settings.batch_type/0."},{"ref":"Riemannx.Settings.Default.html#checkout_timeout/0","title":"Riemannx.Settings.Default.checkout_timeout/0","type":"function","doc":"Callback implementation for Riemannx.Settings.checkout_timeout/0."},{"ref":"Riemannx.Settings.Default.html#events_host/0","title":"Riemannx.Settings.Default.events_host/0","type":"function","doc":"Callback implementation for Riemannx.Settings.events_host/0."},{"ref":"Riemannx.Settings.Default.html#host/0","title":"Riemannx.Settings.Default.host/0","type":"function","doc":"Callback implementation for Riemannx.Settings.host/0."},{"ref":"Riemannx.Settings.Default.html#max_overflow/1","title":"Riemannx.Settings.Default.max_overflow/1","type":"function","doc":"Callback implementation for Riemannx.Settings.max_overflow/1."},{"ref":"Riemannx.Settings.Default.html#max_udp_size/0","title":"Riemannx.Settings.Default.max_udp_size/0","type":"function","doc":"Callback implementation for Riemannx.Settings.max_udp_size/0."},{"ref":"Riemannx.Settings.Default.html#metrics_module/0","title":"Riemannx.Settings.Default.metrics_module/0","type":"function","doc":"Callback implementation for Riemannx.Settings.metrics_module/0."},{"ref":"Riemannx.Settings.Default.html#module/1","title":"Riemannx.Settings.Default.module/1","type":"function","doc":"Callback implementation for Riemannx.Settings.module/1."},{"ref":"Riemannx.Settings.Default.html#options/1","title":"Riemannx.Settings.Default.options/1","type":"function","doc":"Callback implementation for Riemannx.Settings.options/1."},{"ref":"Riemannx.Settings.Default.html#pool_name/1","title":"Riemannx.Settings.Default.pool_name/1","type":"function","doc":"Callback implementation for Riemannx.Settings.pool_name/1."},{"ref":"Riemannx.Settings.Default.html#pool_size/1","title":"Riemannx.Settings.Default.pool_size/1","type":"function","doc":"Callback implementation for Riemannx.Settings.pool_size/1."},{"ref":"Riemannx.Settings.Default.html#port/1","title":"Riemannx.Settings.Default.port/1","type":"function","doc":"Callback implementation for Riemannx.Settings.port/1."},{"ref":"Riemannx.Settings.Default.html#priority!/1","title":"Riemannx.Settings.Default.priority!/1","type":"function","doc":"Callback implementation for Riemannx.Settings.priority!/1."},{"ref":"Riemannx.Settings.Default.html#retry_count/1","title":"Riemannx.Settings.Default.retry_count/1","type":"function","doc":"Callback implementation for Riemannx.Settings.retry_count/1."},{"ref":"Riemannx.Settings.Default.html#retry_interval/1","title":"Riemannx.Settings.Default.retry_interval/1","type":"function","doc":"Callback implementation for Riemannx.Settings.retry_interval/1."},{"ref":"Riemannx.Settings.Default.html#send_timeout/0","title":"Riemannx.Settings.Default.send_timeout/0","type":"function","doc":"Callback implementation for Riemannx.Settings.send_timeout/0."},{"ref":"Riemannx.Settings.Default.html#strategy/1","title":"Riemannx.Settings.Default.strategy/1","type":"function","doc":"Callback implementation for Riemannx.Settings.strategy/1."},{"ref":"Riemannx.Settings.Default.html#type/0","title":"Riemannx.Settings.Default.type/0","type":"function","doc":"Callback implementation for Riemannx.Settings.type/0."},{"ref":"Riemannx.Settings.Default.html#t:conn_type/0","title":"Riemannx.Settings.Default.conn_type/0","type":"type","doc":""},{"ref":"readme.html","title":"Riemannx |","type":"extras","doc":"Riemannx | A fully featured riemann client built on the reliability of poolboy and the awesome power of Elixir!"},{"ref":"readme.html#tl-dr","title":"Riemannx | - TL;DR","type":"extras","doc":"Riemannx is a riemann client built in elixir, currently it&#39;s the only client in elixir that supports UDP and TLS (as well as TCP). There is also a batching mode you can use that works with any of the transports. It has an experimental combined option that makes the best of both TCP and UDP - in the combined mode UDP is the favoured approach but if the message size exceeds the max udp size set TCP will be used. As of 2.1.0 TLS connections are supported. As of 2.2.0 You can now query the index. As of 2.3.0 You can specify a host in config or we will work one out for you. As of 2.4.0 You can set a priority for the workers. As of 3.0.0 configuration entries are separate for the different connection types (see: Migrating to 3.0+) - in all 3.x versions there is a legacy settings backend if you want to upgrade without breaking your previous setup. As of 4.0.0 combined batching is the default connection type and the legacy config is removed (see: Batching) support for time_micros was added (see: Micro Time)."},{"ref":"readme.html#contents","title":"Riemannx | - Contents","type":"extras","doc":"Prerequisites Erlang Elixir Riemann Installation Examples Config Synchronous Asynchronous TLS Querying the index Special Notes Batching Micro Time Host Injection Process Priority Migrating to 3.0+ Settings Backend Metrics Backend Contributions Acknowledgements"},{"ref":"readme.html#1-prerequisites","title":"Riemannx | - 1. Prerequisites","type":"extras","doc":"As always there are prerequisites required before using Riemannx, most of these are obvious (elixir, erlang) but contain some information on which versions are tested and supported. Erlang Currently all erlang versions ~&gt; 18 are supported. This includes 20, 20.1 is not yet tested but I foresee no great problems there. Tested by travis: OTP: 18.0 OTP: 19.3 OTP: 20.0 Elixir I have tried to ensure compatibility from 1.3.4 onwards and will continue to do so where appropriate. Tested combinations: OTP: 18.0 Elixir: 1.3.4 / 1.4.5 / 1.5.1 OTP: 19.3 Elixir: 1.3.4 / 1.4.5 / 1.5.1 OTP: 20.0 Elixir: 1.4.5 / 1.5.1 Riemann As is often the case, a client is fairly useless without it&#39;s server counterpart - for more information about riemann visit http://riemann.io. The client has only been battle tested on: 0.2.11. From version 4.0.0 of the client you will need to set use_micro to false if you use a version of riemann older than 0.2.13 and aren&#39;t setting the time field yourself. It should work with 0.3.0 but again hasn&#39;t been formerly tested (anyone wanting to work on integration tests I would greatly appreciate it)."},{"ref":"readme.html#2-installation","title":"Riemannx | - 2. Installation","type":"extras","doc":"Installation happens just like any other elixir library, add it to your mix file and the rest is history: def deps do [{:riemannx, &quot;~&gt; 4.0&quot;}] end Make sure you add riemannx to the applications list in your mix.exs file also, this ensures it is started with your app and that it will be included in your releases (if you use a release manager): applications: [:logger, :riemannx]"},{"ref":"readme.html#3-examples","title":"Riemannx | - 3. Examples","type":"extras","doc":"To use riemannx all you need to do is fill out some config entries - after that everything just happens automagically (save for the actual sending of course). Below is a comprehensive list of available options: Config config :riemannx, [ host: &quot;localhost&quot;, # The riemann server event_host: &quot;my_app&quot;, # You can override the host name sent to riemann if you want (see: Host Injection) send_timeout: 30_000, # Synchronous send timeout checkout_timeout: 30_000, # Timeout for checking out a poolboy worker type: :batch, # The type of connection you want to run (:tcp, :udp, :tls, :combined, :batch) settings_module: Riemannx.Settings.Default # The backend used for reading settings back metrics_module: Riemannx.Metrics.Default # The backend used for sending metrics use_micro: true # Set to false if you use a riemann version before 0.2.13 batch_settings: [ type: :combined # The underlying connection to use when using batching. size: 50, # The size of batches to send to riemann. interval: {1, :seconds} # The interval at which to send batches. ] tcp: [ port: 5555, retry_count: 5, # How many times to re-attempt a TCP connection retry_interval: 1000, # Interval to wait before the next TCP connection attempt (milliseconds). priority: :high, # Priority to give TCP workers. options: [], # Specify additional options to be passed to gen_tcp (NOTE: [:binary, nodelay: true, packet: 4, active: true] will be added to whatever you type here as they are deemed essential) pool_size: 5, # How many TCP workers should be in the pool. max_overflow: 5, # Under heavy load how many more TCP workers can be created to meet demand? strategy: :fifo # The poolboy strategy for retrieving workers from the queue ], udp: [ port: 5555, priority: :high, options: [], # Specify additional options to be passed to gen_udp (NOTE: [:binary, sndbuf: max_udp_size()] will be added to whatever you type here as they are deemed essential) max_size: 16_384, # Maximum accepted packet size (this is configured in your Riemann server) pool_size: 5, max_overflow: 5, strategy: :fifo ], tls: [ port: 5554, retry_count: 5, # How many times to re-attempt a TLS connection retry_interval: 1000, # Interval to wait before the next TLS connection attempt (milliseconds). priority: :high, options: [], # Specify additional options to be passed to :ssl (NOTE: [:binary, nodelay: true, packet: 4, active: true] will be added to whatever you type here as they are deemed essential) pool_size: 5, max_overflow: 5, strategy: :fifo ] ] Riemannx supports two send methods, one asynchronous the other synchronous: Synchronous Send Synchronous sending allows you to handle the errors that might occur during send, below is an example showing both how this error looks and what happens on a successful send: event = [service: &quot;riemannx-elixir&quot;, metric: 1, attributes: [a: 1], description: &quot;test&quot;] case Riemannx.send(event) do :ok -&gt; &quot;Success!&quot; [error: error, msg: encoded_msg] -&gt; # The error will always be a string so you can output it as it is. # # The encoded message is a binary blob but you can use the riemannx proto # msg module to decode it if you wish to see it in human readable form. msg = encoded_msg |&gt; Riemannx.Proto.Msg.decode() Logger.warn(&quot;Error: \#{error} Message: \#{inspect msg}&quot;) end Asynchronous Send Asynchronous sending is much faster but you never really know if your message made it, in a lot of cases this kind of sending is safe enough and for most use cases the recommended choice. It&#39;s fairly simple to implement: event = [service: &quot;riemannx-elixir&quot;, metric: 1, attributes: [a: 1], description: &quot;test&quot;] Riemannx.send_async(event) # Who knows if it made it? Who cares? 60% of the time it works everytime! NOTE: If a worker is unable to send it will die and be restarted giving it a chance to return to a &#39;correct&#39; state. On an asynchronous send this is done by pattern matching :ok with the send command, for synchronous sends if the return value is an error we kill the worker before returning the result. TLS TLS support allows you to use a secure TCP connection with your riemann server, to learn more about how to set this up take a look here: Secure Riemann Traffic Using TLS If you choose to use TLS you will be using a purely TCP setup, combined is not supported (and shouldn&#39;t be either) with TLS: config :riemannx, [ host: &quot;127.0.0.1&quot;, type: :tls, tls: [ port: 5554, retry_count: 5, # How many times to re-attempt a TLS connection retry_interval: 1000, # Interval to wait before the next TLS connection attempt (milliseconds). priority: :high, # SSL Opts are passed to the underlying ssl erlang interface # See available options here: http://erlang.org/doc/man/ssl.html # (NOTE: [:binary, nodelay: true, packet: 4, active: true] will be added to whatever you type here as they are deemed essential) options: [ keyfile: &quot;path/to/key&quot;, certfile: &quot;path/to/cert&quot;, verify_peer: true ], pool_size: 5, max_overflow: 5, strategy: :fifo ] ] Assuming you have set up the server-side correctly this should be all you need to get started. Querying the index Riemann has the concept of a queryable index which allows you to search for specific events, indexes must be specially created in your config otherwise the server will return a &quot;no index&quot; error. # Lets send an event that we can then query Riemannx.send([service: &quot;riemannx&quot;, metric: 5.0, attributes: [v: &quot;2.2.0&quot;]]) # Let&#39;s fish it out events = Riemannx.query(&#39;service ~= &quot;riemannx&quot;&#39;) # [%{attributes: %{&quot;v&quot; =&gt; &quot;2.2.0&quot;}, description: nil, host: _, # metric: nil, service: &quot;riemannx&quot;, state: nil, tags: [], # time: _, ttl: _}] For more information on querying and the language features have a look at the Core Concepts."},{"ref":"readme.html#4-special-notes","title":"Riemannx | - 4. Special Notes","type":"extras","doc":"This section contains some notes on the behaviour of riemannx that may interest you or answer questions you have about certain things. Batching Batching as of 4.0.0 is the default connection behaviour - the default batch size is 50 and the interval is every 1 second. Batching works like so: Whatever is in the queue will be sent every interval. If the size of the queue reaches the set batch size it will be flushed regardless of interval. Batches will be dropped if no workers are available to handle the batch unless checkout_timer is set to :infinity There is a new type called :batch and a settings key called batch_settings:, inside batch_settings you can specify a type for the underlying connection (:tcp, :udp, :combined, :tls). As always combined is the default. Micro Time From version 0.2.13 of riemann it was possible to set time in microseconds - Riemannx now supports and uses the time_micros field (unless you have set the time or time_micros field yourself, riemannx won&#39;t overwrite that). If you are using an older version of riemann it will only use the seconds field. NOTE: If you set both time and time_micros riemann will prioritise the micro time and riemannx will overwrite neither. Host Injection It sounds fancier than it is but basically describes the functionality that adds a host entry to your event if you haven&#39;t specified one. There are 3 ways to specify a host: Do it before you send the event (add a :host key to the keyword list) Add the :event_host key to your config. Let riemannx do it using :inet.gethostname() - we only call that once and save the result, it is not called on every event. The last 2 options are the most favourable as they will keep your code clean. Process Priority In this client there is the opportunity to set a priority for your workers allowing you to place higher or less priority on the sending of your stats to riemann. The difference setting a priority makes depends heavily on the hardware and how you have set your other priorities in general, more info can be found here: http://erlang.org/doc/man/erlang.html#process_flag-2 If you try to set the priority to :max riemannx will raise a RuntimeError because that is a terrible idea. It will also raise a RuntimeError if you try :foo because that is also a terrible idea. Migrating to 3.0+ Migrating to 3.0 is essentially just a case of changing your config layout - all of the same options exist except now you have more control over your workers at the type level, this is especially valuable when using the combined setup as you could, say, have a smaller pool of TCP workers and a larger UDP worker pool instead of as it was before (2x whatever pool_size you gave). You can see this new layout here: Config If anything doesn&#39;t make sense here feel free to open an issue so we can expand the README to fix the unclarity. Settings Backend If you want to store your settings elsewhere you can create a backend to read settings from a database for example. Look at the default settings module for the required callbacks. This can be useful if you want to store company-wide settings in one place. Feel free to open an issue if you have questions. Metrics Backend Riemannx supports sending basic metrics, you can create a custom module to support any infrastructure (graphite, influx etc.). There are 3 callbacks currently: udp_message_sent(size) - informs when a udp message is sent and gives the size of the message. tcp_message_sent(size) - informs when a tcp message is sent and gives the size of the message. tls_message_sent(size) - informs when a tls message is sent and gives the size of the message."},{"ref":"readme.html#5-contributions","title":"Riemannx | - 5. Contributions","type":"extras","doc":"Contributions are warmly received, check out the Projects section for some ideas I have written down and for the latest on what is underway. Guidelines This repository uses the Gitflow workflow meaning all PR&#39;s should be pointed towards the develop branch!. Below are some things to consider before creating a PR: I would like to maintain test coverage at 100%! - I may let this slide in urgent cases (bugs etc.) To avoid congesting Travis unnecessarily it would be appreciated if you check the following locally first: mix coveralls.html (Aim for 100%) mix dialyzer (Takes a while and I appreciate you can&#39;t test all erlang/elixir versions) I consider this client feature complete, if your PR breaks backwards compatibility completely or changes pre-existing behaviour/defaults I&#39;d appreciate a heads up and your justifications :)."},{"ref":"readme.html#6-acknowledgements","title":"Riemannx | - 6. Acknowledgements","type":"extras","doc":"A portion of code has been borrowed from the original elixir-riemann client. Most of the protobuf stuff comes from there."}]